/*******************************************************************************
 * WRW - WorldRadio Widget
 * by Alexandre Bazyl <wrw@bazyl.com.br>
 *
 * -- version 1.3   :: JUN/2008
 * -- version 1.1.4 :: OCT/2007
 * -- version 1.1.3 :: OCT/2007
 * -- version 1.1.2 :: SEP/2007
 * -- version 1.0b  :: AUG/2007
 *
 * worldradio.js - Main events
 *
 *******************************************************************************/
var widget_hide=false;

function load()
{
	setupParts();
	
	document.getElementById("lbl_siteURL").innerHTML = "<a class=\"one\" href=\"#\">Visit WRW's Homepage to add new radios</a>";
	//hpNormalLink();
	
	// Oculta os paines e apaga as strings exibidas no player
	Panel.frontHide();
	Volume.hidePanel();
	Display.hideCodec();
	document.getElementById("media_name").innerHTML = "";
	document.getElementById("media_status").innerHTML = "";

	// Carrega as configuracoes
	Controller.load();
	// Configura a parte frontal (popup de radios/paises)
	config_front(-1);
	
	myXMLRequest=false;
	// Verifica se ha atualizacao da configuracao / widget
	if (Config.cfgUpdateWidget)
		Controller.checkUpdates("widget");

	document.getElementById("media_name").innerHTML = "";
}


/*******************************************************************************
 * showBack - funcao chamada pelo btn_Info para exibir a parte de tras do widget
 *******************************************************************************/
function showBack(event)
{
	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);

	// Verifica se existe alguma radio tocando e para o scroll
	if (Streaming.isPlaying && Streaming.radio!=0)
		clearTimeout(Display.timeScroll);
		
	// Limpa e popula o popup dos paises
	Controller.clearPopup("popup_backCountry");
	var numpais = Country.populate("popup_backCountry", -1);

	// Preenche o popup e as caixas de texto das radios
	// change_backCountry(null);
	Controller.countryChangeBackPopup();
	
	// Exibe o frame de paises
	Frame.show("country");		// Exibe o frame "country"
	
	// Oculta o painel de mensagens
	Panel.backHide();
	
	// Atualiza checkboxes do frame 'Config'
	Config.setParameters();
	
	// Zera a variavel de controle de alteracoes
	//Config.isChangedConfig = false;
	//Config.isChangedRadio = false;
	//Config.isChangedCountry = false;
}


/*******************************************************************************
 * showFront - funcao chamada pelo btn_Done para exibir a parte da frente do widget
 *******************************************************************************/
function showFront()
{
	// your widget needs to show the front

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
		
	config_front(-1);
}


/*******************************************************************************
 * config_front - funcao chamada quando a janela principal (player) eh exibida.
 *                Atualiza os popups dos paises e das radios de acordo com as
 *                structs 'paises' e 'radios'.
 * Entrada: memradio - numero da radio caso tenha sido pressionado um botao
 *                     de memoria e -1, caso contrario
 *******************************************************************************/
function config_front(memradio)
{
	var where=0;
	if (memradio>0) 
		where=1;	// Para indicar que o "caller" foi o pressionamento de um botao de memoria

	// Limpa os popups (paises e radio)
	//Controller.clearPopup("popup_plCountry");
	//Controller.clearPopup("popup_plRadio");

	// Preenche os popups
	if(Streaming.isPlaying && Streaming.radio!=0 && memradio<1)
		memradio=Streaming.radio;
	else if (Memory.radioSelected>0)
		memradio=Memory.radioSelected;

	// Recupera o pais da rádio selecionada (que está tocando ou do botão de memória pressionado)
	if (memradio > 0)
		var chkpais = Radio.getAttrib(memradio, "pais");
	else var chkpais=-1;

	// Populate a popup de paises e radios
	var numpais = Country.populate("popup_plCountry", chkpais);		
	Radio.populate("popup_plRadio", numpais, memradio);

	// Ajusta a apresentacao dos popups (_img)
	Controller.setPopupText();

	// Atualiza a aparencia dos botoes de memoria
	Memory.refreshButtons();
	// Verifica se existe algum botao de memoria associado a radio
	Memory.checkButtons();
	
	// Indica que a origem foi um botao de memoria pressionado
	if(where==1)
		return;
		
	// Nao exibe a string media_status e media_name
	//document.getElementById("media_status").innerHTML = "";
	document.getElementById("media_name").innerHTML = "";
	
	// Se estiver um scroll então pára
	if (Display.timeScroll)
		clearTimeout(Display.timeScroll);
	
	// Info de MemSet e MemDel
	document.getElementById("lbl_mem_set").style.color = "#001F00";
	document.getElementById("lbl_mem_del").style.color = "#1F0000";
	
	// Verifica se existe alguma radio tocando
	if (Streaming.isPlaying && Streaming.radio!=0) {
		// Ajusta as strings para reiniciar o scroll
		if (Display.msgScroll == 1)	Display.stringScroll = Display.stringScrollOriginal;
		else Display.stringScroll = Display.stringScrollMetadata;
		// Inicia scroll com o nome da radio
		Display.timeScroll = setTimeout("Display.scrollStatus(13)",500);
	}
}

function remove()
{
	// your widget has just been removed from the layer
	// remove any preferences as needed
	// widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

function hide()
{
	// your widget has just been hidden stop any timers to
	// prevent cpu usage
	widget_hide=true;
}


function show()
{
	// your widget has just been shown.  restart any timers
	// and adjust your interface as needed
	widget_hide=false;
}

if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}


/******************************** DROP EVENTS **********************************/

/*******************************************************************************
 * onDropEvent - Trata o evento de arrastar URLs para o widget
 *******************************************************************************/
function onDropEvent(event) 
{
	var uri = null;
	try {
		// attempt to load the URL
		uri = event.dataTransfer.getData("text/plain"); //text/uri-list");
	} catch (ex) {
	}
	
	// if the acquisition is successful:
	var ret=-1;
	if (uri) {
		ret=Parser.decodeURL(uri);
	}
	// Se a URL arrastada for invalida, a funcao decodeURI retornara -1
	if(ret==-1) {
		Panel.setStatusMessage("Invalid URL!", false, "default");
		Panel.showStatusMessage();
		Panel.statusTime = setTimeout("Panel.hideStatusMessage()", 4000);
	}
//	else	// Salva configuracao
//		Controller.save();
		
	event.stopPropagation();
	event.preventDefault();
}

// The dragenter, dragover, and dragleave functions are implemented but not used.
// They can be used if you want to change the image when it enters the widget.
function dragenter (event)
{
	event.stopPropagation();
	event.preventDefault();
}

function dragover (event)
{
	event.stopPropagation();
	event.preventDefault();
}

function dragleave (event)
{
	event.stopPropagation();
	event.preventDefault();
}

function createRow (title, link, date, even)
{
  var row = document.createElement ('div');
  row.setAttribute ('class', 'row ' + (even ? 'light' : 'dark'));
  
  var title_div = document.createElement ('div');
  title_div.innerText = title;
  title_div.setAttribute ('class', 'title');
  if (link != null)
  {
    title_div.setAttribute ('the_link', link);
    title_div.setAttribute ('onclick', 'clickOnTitle (event, this);');
  }
  row.appendChild (title_div);
  
  if (date != null)
  {
    var date_div = document.createElement ('div');
    date_div.setAttribute ('class', 'date');
    date_div.innerText = date; //createDateStr (date);
    
    row.appendChild (date_div);
  }
  
  return row;  
}

/************************************ BACK *************************************/

/*******************************************************************************
 * btn_Done - botao Done pressionado
 *******************************************************************************/
function btn_Done(event)
{
	// Salva as alteracoes
	Controller.save();
	showFront();
}


/*******************************************************************************
 * abaRadio - aba Radios selecionada
 *******************************************************************************/
function abaRadio(event) 
{
	Frame.show("radio");
	Controller.countryChangeBackPopup(null);		///////////////////////
}


/*******************************************************************************
 * abaCountry - aba Countries selecionada
 *******************************************************************************/
function abaCountry(event) 
{
	Frame.show("country");
}


/*******************************************************************************
 * abaConfig - aba Config selecionada
 *******************************************************************************/
function abaConfig(event) 
{
	Frame.show("config");
}


/*******************************************************************************
 * abaUpdate - aba Update selecionada
 *******************************************************************************/
function abaUpdate(event)
{
	Frame.show("update");
}


/*******************************************************************************
 * hnd_addCountry - botao Add Country pressionado
 *******************************************************************************/
function hnd_addCountry(event)
{
	Controller.countryAdd();
}


/*******************************************************************************
 * hnd_updateCountry - botao Update Country pressionado
 *******************************************************************************/
function hnd_updateCountry(event)
{
	Controller.countryUpdate();
}


/*******************************************************************************
 * hnd_delCountry - botao Del Country pressionado
 *******************************************************************************/
function hnd_delCountry(event)
{
	Controller.countryDel();
}


/*******************************************************************************
 * hnd_changeBackCountryList - popup (traseira) de paises modificada
 *******************************************************************************/
function hnd_changeBackCountryList(event)
{
	Controller.countryChangeBackPopup();
}


/*******************************************************************************
 * hnd_addRadio - botao Add Radio pressionado
 *******************************************************************************/
function hnd_addRadio(event)
{
	Controller.radioAdd();
}


/*******************************************************************************
 * hnd_updateRadio - botao Update Radio pressionado
 *******************************************************************************/
function hnd_updateRadio(event)
{
	Controller.radioUpdate();
}


/*******************************************************************************
 * hnd_delRadio - botao Del Radio pressionado
 *******************************************************************************/
function hnd_delRadio(event)
{
	Controller.radioDel();
}


/*******************************************************************************
 * hnd_changeBackRadioList - popup de radios modificada
 *******************************************************************************/
function hnd_changeBackRadioList(event)
{
	Controller.radioChangeBackPopup();
}


/*******************************************************************************
 * btn_verifyUpdates - button "Verify Now". Botao usado para verificar a
 *                     existencia de atualizacao do widget 
 *******************************************************************************/ 
function btn_verifyUpdates(event) 
{
	Controller.checkWidgetUpdate();
}


/*******************************************************************************
 * btn_downloadRadios - button "Download All Radios". Botao usado para fazer
 *                      o download de todas as radios do site
 *******************************************************************************/ 
function btn_downloadRadios(event) 
{
	Controller.checkRadioUpdate();
}


/*********************************** FRONT *************************************/

/*******************************************************************************
 * btn_Info - Button 'I' para exibir a parte de tras do widget
 *******************************************************************************/
function btn_Info(event) {
	showBack();
}


/*******************************************************************************
 * btn_yesUpdate - Button 'Yes' na verificacao da atualizao de configuracao
 *******************************************************************************/
function btn_yesUpdate(event) 
{
	Controller.acceptUpdate();
}


/*******************************************************************************
 * btn_noUpdate - Button 'No' na verificacao da atualizao de configuracao
 *******************************************************************************/
function btn_noUpdate(event) 
{
	Controller.cancelUpdate();
}


function btn_okUpdate(event)
{
	Panel.frontHide();
}


/*******************************************************************************
 * hnd_changeFrontCountryList - Popup de Paises (Front) modificada
 *******************************************************************************/
function hnd_changeFrontCountryList(event)
{
	Controller.countryChangeFrontPopup();
}


/*******************************************************************************
 * hnd_changeFrontRadiosList - Popup de Radios (Front) modificada
 *******************************************************************************/
function hnd_changeFrontRadioList(event)
{
    Controller.radioChangeFrontPopup();
}


/*******************************************************************************
 * hnd_incVolume - Botao de aumentar o volume pressionado
 *******************************************************************************/
function hnd_incVolume(event)
{
	Volume.inc();
}


/*******************************************************************************
 * hnd_decVolume - Botao de diminuir o volume pressionado
 *******************************************************************************/
function hnd_decVolume(event)
{
	Volume.dec();
}


/*******************************************************************************
 * hnd_enablememory - Botao 'M' pressionado
 *******************************************************************************/
function hnd_enableMemory(event)
{
	Memory.enable();
}


/*******************************************************************************
 * btnmemory - Pressionamento de um dos botoes "memX" (X = 1..10).
 *             VRF se eh para 'set' ou 'get' (definido na variavel memory[0])
 *             a radio referente ao botao de memoria pressionado
 *******************************************************************************/
function btnmemory(event, numbtn)
{
	Memory.processButtonClick(numbtn);
}

function hnd_scroll(event)
{
	Display.changeScroll();
}


function hnd_changeAutoplay(event)
{
	Config.isChangedConfig = true;
}

function hnd_changeMetadata(event)
{
	Config.isChangedConfig = true;
}

function hnd_changeUpdateWidget(event)
{
	Config.isChangedConfig = true;
}


function hnd_changeAllowUpdate(event)
{
	Config.isChangedConfig = true;
}


function hnd_play(event)
{
	Streaming.play();
}


function hnd_stop(event)
{
    Streaming.stop();
}
